Bug 50061 - Semicolon character '%3B' seems to be decoded to ';' too early.
Summary: Semicolon character '%3B' seems to be decoded to ';' too early.
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_proxy (show other bugs)
Version: 2.2.14
Hardware: Other Linux
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2010-10-08 10:57 UTC by david.goate
Modified: 2018-11-07 21:09 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description david.goate 2010-10-08 10:57:40 UTC
We are using mod_proxy 2.2.14 on an Intel Linux box to proxy requests from Apache to jBoss 5.01 via AJP.

Mod_proxy seems to be decoding the escaped semicolon character before passing the request to jBoss.

E.g.
http://myhost/myapp/service/some%3Bpath -->
http://myhost/myapp/service/some;path

If we access jBoss directly without going through Apache the issue does not occur.
http://myhost/myapp/service/some%3Bpath -->
http://myhost/myapp/service/some%3Bpath

I wondered if this was some regression as I have read similar comments in 2.2.6 that claimed that this was fixed in 2.2.7 (https://issues.apache.org/bugzilla/show_bug.cgi?id=43972)
Comment 1 Eric Covener 2011-03-12 21:33:00 UTC
This is not fixed in 2.2.x, but mod_proxy is not really the culprit. 

IIUC, this is the core decoding %3B->; (which seems wrong), and proxy only uses untouched r->unparsed_uri with the "noncanon" flag to ProxyPass.
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:05 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.